/*
Class for reading news from Freshmeat (freshmeat.net). 99-06-11.
Author: Carl Smith
Shamelessly ripped from slashdotserver by Simon Kgstrm

Bygs:
* No time yet (included in date though)...
*/

#include <qstring.h>
#include <qfile.h>
#include <qtextstream.h>

#include "readNews.h"

/*
Class ReadNews - Reads news from an lynx-dumped infile, outputs generic news.
----------------------------------------------------------------------------
*/
ReadNews::ReadNews ()
{
}

ReadNews::ReadNews (QString inFilename, QString outFilename )
{
  inFile = new QFile (inFilename);
  outFile = new QFile (outFilename);
}

ReadNews::~ReadNews ()
{
  delete inFile;
  delete outFile;
}

/** Get the fork command for freshmeat*/
QString ReadNews::getForkCommand()
{
  return "lynx -nolist -reload -dump http://freshmeat.net";
}

/** Read the news-file */
int ReadNews::generateNewsfile()
{
  int count=0;
  int searchIndex=-1;
  int waitCount=-1;
  int dateRow=-1;
  bool found=false;
  QString date;
  QString time;
  QString title;
  QString body;
  QString articlePic;
  QString s;

  if (inFile->size()==0)
    return 1;
  if (!inFile->open(IO_ReadOnly))
    return 1;
  if (!outFile->open(IO_WriteOnly))
    return 2;

  QTextStream in (inFile);
  QTextStream out (outFile);
  out << "NEWSSOURCE:Freshmeat.net\n";
  
  while ( (!in.eof()) && (found == false))
    {
      s = in.readLine();
      searchIndex = s.find("FAQ |");
      if (searchIndex != -1) // Then read 4 lines more...
	{
	  found = true;
	  int count = 1;
	  while (!in.eof() && count <= 4)
	    {
	      s = in.readLine();
	      count++;
	    }
	  //	  if (!in.eof())
	  // s = in.readLine();
	}
    }
  while (!in.eof() )
    {
      title = s.simplifyWhiteSpace();
      if (!in.eof()) s = in.readLine();
      date = s.right( s.length() - s.find("-")-1 ).simplifyWhiteSpace();
      
      if (!in.eof()) s = in.readLine();
      while ( (!in.eof()) && (s.find("__________________________") == -1))
	{
	  if ( (s.find("Changes:") != -1) || 
	       (s.find("License:") != -1) || 
	       (s.find("Category:") != -1) ) 
	    body.append("\nTEXT:\nTEXT:"+s.simplifyWhiteSpace());
	  else
	    {
	      if (body.length() > 0) 
		body.append(" "+s.simplifyWhiteSpace());
	      else
		body.append(s.simplifyWhiteSpace());
	    }		
	  s = in.readLine();
	}
      if (!in.eof()) s = in.readLine();
      if (!in.eof()) s = in.readLine();
      
      if ( (date != "navigator") && (date != "") ) { 
	out << "DATE:" + date + "\n";
	out << "TIME:Freshmeat\n";
	out << "TITLE:" + title + "\n";
	out << "TEXT:" + body + "\n";
	title = "";
	body = "";
	date = "";
      }
    }
  inFile->close();
  outFile->close();
  return 0;
}








